----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:19:35 02/20/2011 
-- Design Name: 
-- Module Name:    Pulser - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Pulser is
    Port ( clock 	: in STD_LOGIC;
			  reset 	: in STD_LOGIC;
			  pwmOut : out  STD_LOGIC;
           pwmOutInverted : out  STD_LOGIC;
			  sineOut : out integer range -128 to 127);
end Pulser;

architecture Behavioral of Pulser is

	component PwmWave is
		Port(clock 	: in STD_LOGIC;
			  reset 	: in STD_LOGIC;
			  pwmOut : out STD_LOGIC;
			  pwmOutInverted : out STD_LOGIC;
			  clockScaler : in integer;
			  dutyCycle : in integer);
	end component;
	
	component SineWave is
		Port(clock 		: in STD_LOGIC;
			  reset		: in STD_LOGIC;
			  sineOut 	: out integer range -128 to 127;
			  clockScaler : in integer);
	end component;
	
	--default werte
	signal pwmGenerationPrescaler : integer := 100;
	signal dutyCycle : integer := 20;
	
	signal sineGenerationPrescaler : integer := 1;
	
begin

	 PwmComponent:  PwmWave  port map (clock, reset, pwmOut, pwmOutInverted, pwmGenerationPrescaler, dutyCycle);
	 SineComponent: SineWave port map (clock, reset, sineOut, sineGenerationPrescaler);
	 
end Behavioral;

