----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:19:35 02/20/2011 
-- Design Name: 
-- Module Name:    Pulser - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity PwmWave is
    Port ( clock : in STD_LOGIC;
			  reset : in STD_LOGIC;
			  pwmOut : out  STD_LOGIC;
           pwmOutInverted : out  STD_LOGIC;
			  clockScaler : in integer;
			  dutyCycle : in integer);
end PwmWave;

architecture Behavioral of PwmWave is

	signal frequencyCounter : integer;

begin

	process(clock, reset)
	begin
		if reset = '1' then
			
			frequencyCounter <= 0;
			
		else
			if rising_edge(clock) then
				
				if frequencyCounter < dutyCycle then
					pwmOut <= '1';
					pwmOutInverted <= '0';
				else
					pwmOut <= '0';
					pwmOutInverted <= '1';
				end if;
								
				frequencyCounter <= frequencyCounter + 1;
				
				if frequencyCounter = clockScaler then
					frequencyCounter <= 0;
				end if;
			
			end if;
		end if;
	end process;

end Behavioral;

