library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;  --try to use this library as much as possible.

entity SineWave is
port (clock 	: in STD_LOGIC;
		reset		: in STD_LOGIC;
      sineOut  : out integer range -128 to 127;
		clockScaler : in integer);
end sinewave;

architecture Behavioral of sinewave is
	
	signal i : integer range 0 to 30:=0;
	type memory_type is array (0 to 29) of integer range -128 to 127;
	signal sine : memory_type :=(0,16,31,45,58,67,74,77,77,74,67,58,45,31,16,0,-16,-31,-45,-58,-67,-74,-77,-77,-74,-67,-58,-45,-31,-16);
	signal clockCounter : integer;

begin

	process(clock, reset)
		begin
			if reset = '1' then
			
				i <= 0;
				clockCounter <= 0;
				
			else
				if(rising_edge(clock)) then    
					
					clockCounter <= clockCounter + 1;
					
					if clockCounter = clockScaler then
						
						sineOut <= sine(i);
						clockCounter <= 0;
					
						i <= i+ 1;
					
						if(i = 29) then
							i <= 0;
						end if;
						
					end if;
					
				end if;
			end if;
	end process;

end Behavioral;